%define realver 2.4.4
%define docver  2.4.4
%define dirver  2.4

%define lib_name_orig	libpython
%define lib_major	%{dirver}
%define lib_name	%{lib_name_orig}%{lib_major}

Summary:	An interpreted, interactive object-oriented programming language
Name:		python
Version:	2.4.4
Release:	3
License:	Modified CNRI Open Source License
Group:		Libraries
Source0:	http://www.python.org/ftp/python/2.4.4/Python-2.4.4.tar.bz2
Source1:	http://www.python.org/ftp/python/doc/2.4.4/html-%{docver}.tar.bz2
Patch0:		Python-2.1-pythonpath.patch.bz2
Patch1:		Python-gdbm-dbm.diff
URL:		http://www.python.org/
Buildroot:      %{_tmppath}/%{name}-root
BuildRequires:	gmp-devel gdbm-devel gpm-devel ncurses-devel blt-devel
BuildRequires:	readline-devel zlib-devel XFree86-devel openssl-devel
BuildRequires:	expat-devel libtermcap-devel tcl-devel tk-devel
BuildRequires:	autoconf

%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. Python includes
modules, classes, exceptions, very high level dynamic data types and
dynamic typing. Python supports interfaces to many system calls and
libraries, as well as to various windowing systems (X11, Motif, Tk,
Mac and MFC).

Programmers can write new built-in modules for Python in C or C++.
Python can be used as an extension language for applications that
need a programmable interface. This package contains most of the
standard Python modules, as well as modules for interfacing to the
Tix widget set for Tk and RPM.

Note that documentation for Python is provided in the python-docs
package.

%package 	devel
Summary:	The libraries and header files needed for Python development
Group:		Development
Icon:		python-devel-logo.xpm

%description 	devel
The Python programming language's interpreter can be extended with
dynamically loaded extensions and can be embedded in other programs.
This package contains the header files and libraries needed to do
these types of tasks.

Install devel if you want to develop Python extensions.  The
python package will also need to be installed.  You'll probably also
want to install the python-docs package, which contains Python
documentation.

%package 	docs
Summary:	Documentation for the Python programming language
Icon:		python-docs-logo.xpm
Group:		Development

%description 	docs
The python-docs package contains documentation on the Python
programming language and interpreter.  The documentation is provided
in ASCII text files and in LaTeX source files.

Install the python-docs package if you'd like to use the documentation
for the Python language.

%prep
%setup -q -n Python-%{version}
%patch0 -p1 -b .path
%patch1 -p0
autoconf

mkdir html
bzcat %{SOURCE1} | tar xv  -C html

%build
OPT="$RPM_OPT_FLAGS"
export OPT
configure \
    --build=i386-pc-linux \
    --host=i386-pc-linux \
    --prefix=/usr \
    --enable-shared \
    --with-threads \
    --with-cycle-gc \
    --with-cxx=g++ \
    --without-libdb \
    --enable-ipv6
make;  #make test

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}

#  set the install path
echo '[install_scripts]' >setup.cfg
echo 'install_dir='"${RPM_BUILD_ROOT}/usr/bin" >>setup.cfg

# python is not GNU and does not know fsstd
mkdir -p $RPM_BUILD_ROOT%{_mandir}
make DESTDIR=$RPM_BUILD_ROOT install

# Provide a libpython%{dirver}.so symlink in /usr/lib/puthon*/config, so that
# the shared library could be found when -L/usr/lib/python*/config is specified
(cd $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/config; ln -sf ../../%{lib_name}.so .)

# idle
mkdir -p $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/site-packages
cat << EOF > $RPM_BUILD_ROOT%{_bindir}/idle
#!/bin/bash
exec /usr/lib/python%{dirver}/site-packages/idle/idle.py
EOF

# idle 
cp Tools/scripts/idle $RPM_BUILD_ROOT%{_bindir}/idle

# modulator
cat << EOF > $RPM_BUILD_ROOT%{_bindir}/modulator
#!/bin/bash
exec /usr/lib/python%{dirver}/site-packages/modulator/modulator.py
EOF
cp -r Tools/modulator $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/site-packages/

# pynche
cat << EOF > $RPM_BUILD_ROOT%{_bindir}/pynche
#!/bin/bash
exec /usr/lib/python%{dirver}/site-packages/pynche/pynche
EOF
rm -f Tools/pynche/*.pyw
cp -r Tools/pynche $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/site-packages/

chmod 755 $RPM_BUILD_ROOT%{_bindir}/{idle,modulator,pynche}

ln -f Tools/modulator/README Tools/modulator/README.modulator
ln -f Tools/pynche/README Tools/pynche/README.pynche

rm -f modules-list.full
for n in $RPM_BUILD_ROOT/usr/lib/python%{dirver}/*; do
  [ -d $n ] || echo $n
done >> modules-list.full

for mod in $RPM_BUILD_ROOT/usr/lib/python%{dirver}/lib-dynload/* ; do
  [ `basename $mod` = _tkinter.so ] || echo $mod
done >> modules-list.full
sed -e "s|$RPM_BUILD_ROOT||g" < modules-list.full > modules-list

# menu support
mkdir -p $RPM_BUILD_ROOT%{_libdir}/menu
cat > $RPM_BUILD_ROOT%{_libdir}/menu/tkinter << EOF
?package(tkinter): needs="gnome" \
section="Applications/Development/Development environments" \
title="IDLE" \
longtitle="IDE for Python" \
command="NO_XALF %{_bindir}/idle" \
icon="development_section.png"

?package(tkinter): needs=x11 \
section="Applications/Development/Development environments" \
title="IDLE" \
longtitle="IDE for Python" \
command="%{_bindir}/idle" \
icon="development_section.png"
EOF

cd $RPM_BUILD_ROOT/usr/bin; rm python; ln -sf python%{dirver} python
cd ../lib; ln -sf python%{dirver}/config/libpython%{dirver}.a libpython%{dirver}.a;
ln -sf python%{dirver}/config/libpython%{dirver}.a libpython.a; cd -
ln -sf python%{dirver} $RPM_BUILD_ROOT%{_libdir}/python
ln -sf python%{dirver} $RPM_BUILD_ROOT%{_includedir}/python
# remove uneeded tests - everything passed
rm -rf $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/test

%clean
rm -rf $RPM_BUILD_ROOT
rm -f modules-list modules-list.full

%files
%defattr(-, root, root, 755)
%{_bindir}/python
%{_bindir}/python%{dirver}
%{_mandir}
%{_libdir}/python
%{_libdir}/python%{dirver}
%{_libdir}/*.so.*
%{_libdir}/*.so

%files devel
%defattr(-, root, root, 755)
%{_includedir}
%{_libdir}/menu/tkinter
%{_bindir}/idle
%{_bindir}/pydoc
%{_bindir}/pynche
%{_bindir}/modulator
%{_bindir}/smtpd.py
%{_libdir}/*.a

%files docs
%defattr(-,root,root,755)
%doc html/*/*
